import { isNull, isEmpty, isUndefined } from "../../Helpers/Functions";

const TAB = 9;

function insertAfter(newNode, referenceNode) {
    referenceNode.parentNode.insertBefore(newNode, referenceNode.lastSibling);
}

function input(child) {
    const el = child instanceof HTMLElement ? child : (child.elm || child.$el);

    return isUndefined(el.value) ? el.querySelector('input, select, textarea') : el;
}

/*
function value(child) {
    return child.componentInstance && !isUndefined(child.componentInstance.value) ? child.componentInstance.value : (
        child.elm && !isUndefined(child.elm.value) ? child.elm
    );
}
*/

function bindEvents(vnode, child, items) {
    const el = input(child.$vnode);

    el.addEventListener('blur', e => {
        if(e.target.value && child.$vnode.key === items.length - 1) {
            items.push(null);
        }
        else if(isEmpty(e.target.value) && child.$vnode.key < items.length - 1) {
            items.splice(child.$vnode.key, 1);
        }
    });

    el.addEventListener('keydown', e => {
        if(e.keyCode === TAB) {
            if(!event.shiftKey && !isNull(items[items.length - 1])) {
                e.preventDefault();

                items.push(null);
            }
        }
    });

    child.$inputListControl = true;

    return el;
}

export default {

    bind(el, binding, vnode) {
        vnode.context.$children.forEach(child => {
            bindEvents(vnode, child, binding.value);
        });

        vnode.context.$watch(binding.expression, (value) => {
            vnode.context.$children
                .filter(child => !child.$inputListControl)
                .forEach(child => {
                    bindEvents(vnode, child, binding.value).focus();
                });
        });
    },

    unbind(el, binding, vnode) {
        
    }

};
